'FFSubmenu=Tools
'FFName=Ordner lschen

'(c) Harald Maeckler, Dsseldorf 2010

' ********************************************************************
' Folder_Delete.vbs (Script fr FixFoto)
' Funktion:	Lschen des aktuellen Bildordners mit allen Dateien
'
' Version 1.03 vom 21.02.2010	- Text 'Anzeige' gendert
'								- Listenhhe einstellbar ber Konstante LH
' Version 1.02 vom 20.02.2010	- Vergrerung der Anzeige
'								- Anzeige wahlweise mit und ohne Bilder
' Version 1.01 vom 19.02.2010	- F5 muss nach Lschvorgang nicht mehr bettigt werden
' Version 1.00 vom 18.02.2010	- Betaversion
'  
'** Start Kurzbeschreibung *******************************************
' Ordner lschen / Version 1.03
' ==================
' Das Skript dient zum Lschen des aktuellen Bildordners mit allen Dateien
' 
' Voraussetzung zum Lschen eines Ordners mit dem Skript ist, dass keine Unterordner 
' existieren. Diese mssen ggf. zuerst gelscht werden, worauf mit einer Meldung hingewiesen
' wird.
' Bevor man sich entscheidet den Ordner mit allen darin enthaltenen Dateien zu lschen, 
' werden Anzahl und Namen der Dateien zur Kontrolle aufgelistet. Dabei kann man whlen
' ob alle Dateien incl. Bilder oder nur Dateien die keine Bilder sind, angezeigt werden.
' Als Bilder sind Dateien definiert mit der Dateierweiterung JPG, JP2, PNG, TIF oder BMP.
' Will man diese Definition ndern, kann man im Skript die Konstante 'BildFilter' ent-
' sprechend editieren.
'
' Bettigt man 'Lschen' erfolgt noch eine Sicherheitsabfrage und dann wird alles unwieder-
' bringlich entfernt.
'
' Achtung: Eine sptere Wiederherstellung ber den Papierkorb ist nicht mglich.
' ----------
' 
' Tipp
' -----
' Man kann die Hhe der Anzeigenliste mit der Konstanten LH vergrern. Sie kann im Skript
' editiert werden.
'
' Deinstallation des Skripts 'Ordner lschen'
' =========================
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen ange-
' boten, davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach 
' wird die Skriptdatei gelscht und abschlieend die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript aus 
' der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

const BildFilter = ".JPGJP2.PNG.TIF.BMP"					'Bildfilter
const LH = 0												'Listenhhe (pro 8 eine Zeile hher)
const SkriptName = "Folder_Delete.vbs"						'Skriptname

Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
const ForReading = 1, ForWriting = 2

Dim objFS													'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")

Dim SkriptKill : SkriptKill = false
Dim flagOB : flagOB = false
Dim TempFile,Antwort
Dim Ordner,UeberOrdner

'------------------------------------------------------------------------
call Main
'------------------------------------------------------------------------
Sub Main	'### Hauptprogramm

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetImageCount
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

Abbruch = false

'** Start Dialog Ordner lschen **
FF_AddDialog "Ordner lschen",160,153 + LH
FF_AddControl "Ordner lschen","Der Ordner hat","STATIC",5,6,39,10
FF_AddControl "Ordner lschen","AnzFiles","SLEDIT",45,6,24,10
FF_SetControlStyle "Ordner lschen","AnzFiles",2049
FF_AddControl "Ordner lschen","Dateien incl. bzw. excl. Bilder","STATIC",72,6,83,10
FF_AddControl "Ordner lschen","LDateien","LISTBOX",5,18,150,105 + LH
FF_AddControl "Ordner lschen","Liste zeigt","STATIC",6,124 + LH,28,10
FF_AddControl "Ordner lschen","flagOB","BOOL",85,125 + LH,8,8
FF_SetControlStyle "Ordner lschen","flagOB",16384
FF_AddControl "Ordner lschen","alle auer Bildern","STATIC",97,124 + LH,44,10
FF_AddControl "Ordner lschen","flagMB","BOOL",40,125 + LH,8,8
FF_SetControlStyle "Ordner lschen","flagMB",16384
FF_AddControl "Ordner lschen","alle Dateien","STATIC",50,124 + LH,28,10
FF_AddControl "Ordner lschen","?","BUTTON",5,137 + LH,11,11
FF_AddControl "Ordner lschen","Abbrechen","BUTTON",70,137 + LH,33,11
FF_AddControl "Ordner lschen","Lschen","BUTTON",122,137 + LH,33,11
FF_AddControl "Ordner lschen","&d","BUTTON",36,85,1,1
'** End Dialog Ordner lschen **

call Dateiauflistung
if Abbruch then
	msgbox "Zuerst mssen vorhandene Unterordner gelscht werden!",vbExclamation,"Abbruch"
	exit sub
end if

FF_SetControl "Ordner lschen","flagMB",1
FF_ActivateControl "Ordner lschen","&d"

do									'Befehlsabfrage
	Select Case FF_ShowDialog ("Ordner lschen")
	Case "&d"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "flagOB"
		FF_SetControl "Ordner lschen","flagOB",1
		FF_SetControl "Ordner lschen","flagMB",0
		flagOB = true
		FF_SetControl "Ordner lschen","LDateien",""
		call Dateiauflistung		
	Case "flagMB"
		FF_SetControl "Ordner lschen","flagOB",0
		FF_SetControl "Ordner lschen","flagMB",1
		flagOB = false
		FF_SetControl "Ordner lschen","LDateien",""
		call Dateiauflistung		
	Case "?"
		Abbruch = false
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "CANCEL","Abbrechen"
		exit do
	Case "Lschen"
		Antwort = msgbox("Soll wirklich der Ordner" & vbNewLine & "mit allen Dateien unwiederbringlich gelscht werden?" _
				,vbYesNoCancel or vbDefaultButton2 or vbQuestion,"Sicherheitsabfrage")
			if Antwort = vbCancel then exit do
			if Antwort = vbYes then
				FF_SetImagePath UeberOrdner
				objFS.DeleteFolder(Ordner)
				FF_SetImagePath UeberOrdner
				exit do
			end if
	Case Else
	End Select
loop

FF_CloseDialog ("Ordner lschen")
if SkriptKill then	'ggf. Skript 'Ordner lschen' komplett entfernen
	call KillSkript
end if

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim Breite	: Breite = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",Breite,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,Breite,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",Breite/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad
const RegSchluessel = "\FF_FolderDelete\"

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"		'Dateibeispiel
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'TempFile = FF_GetScriptPath & "\BeipackSammlung"	'Ordnerbeispiel
'if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
'TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script" & RegSchluessel
'WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Sub Dateiauflistung
Dim Folder,SubFolder,Files,element,Laenge,Pos,n,strExt
n = 0

Ordner = FF_GetImagePath()
Laenge = len(Ordner)

Set Folder = objFS.GetFolder(Ordner)
UeberOrdner = Folder.ParentFolder

'Unterordner
Set SubFolder = Folder.SubFolders
For Each element in SubFolder
	Abbruch = true
	exit sub
Next

'Dateien
Set Files = Folder.Files
For Each element in Files
	element = mid(element,Laenge+2)
	
	if flagOB then
		Pos = InStrRev(element,".")
		strExt = mid(element,Pos)
	end if
	
	if instr(Ucase(BildFilter), Ucase(strExt)) = 0 or not flagOB then
		FF_SetControl "Ordner lschen","LDateien",element
		n = n + 1
	end if
Next
FF_SetControl "Ordner lschen","AnzFiles",n

End Sub
'------------------------------------------------------------------------
